#ifndef _FS_OCR_C_H_
#define _FS_OCR_C_H_

#ifdef __cplusplus
extern "C" {
#endif


FSErrorCode FSDK_OCREngine_Initialize(const wchar_t* ocr_resource_path);
FSErrorCode FSDK_OCREngine_Release();
FSErrorCode FSDK_OCREngine_SetLogFile(const wchar_t* log_file_path);
FSErrorCode FSDK_OCREngine_SetLanguages(const wchar_t* languages);
FSErrorCode FSDK_OCR_Create(FS_OCR_HANDLE& ocr_return_value);
FSErrorCode FSDK_OCR_Release(FS_OCR_HANDLE& ocr_handle);
FSErrorCode FSDK_OCR_IsEmpty(FS_OCR_HANDLE& ocr_handle, FS_BOOL& return_value);
FSErrorCode FSDK_OCR_OCRPDFPage(FS_OCR_HANDLE& ocr_handle,  FS_PDFPAGE_HANDLE pdf_page, FS_BOOL is_editable);
FSErrorCode FSDK_OCR_OCRPDFDocument(FS_OCR_HANDLE& ocr_handle,  FS_PDFDOC_HANDLE pdf_doc, FS_BOOL is_editable);
#ifdef __cplusplus
}
#endif
#endif
