#ifndef _FS_XFA_C_H_
#define _FS_XFA_C_H_

#ifdef __cplusplus
extern "C" {
#endif



typedef enum _FSAppInfo {
e_FSAppInfoVersion = 0x0,
e_FSAppInfoLanguage = 0x01,
e_FSAppInfoPlatform= 0x02,
e_FSAppInfoVariation= 0x03,
e_FSAppInfoName = 0x04,
e_FSAppInfoType = 0x05,
}FSAppInfo;



typedef enum _FSBeepType {
e_FSBeepTypeError = 0,
e_FSBeepTypeWarning = 1,
e_FSBeepTypeQuestion = 2,
e_FSBeepTypeStatus = 3,
e_FSBeepTypeDefault = 4,
}FSBeepType;



typedef enum _FSStringID {
e_FSStringIDValidateFailed = 1,
e_FSStringIDCalcOverride = 2,
e_FSStringIDModifyField = 3,
e_FSStringIDNotModifyField = 4,
e_FSStringIDAppName = 5,
e_FSStringIDImageFilter = 6,
e_FSStringIDStringIDUnknownCaught = 7,
e_FSStringIDUnableToSet = 8,
e_FSStringIDValueExcalmatory = 9,
e_FSStringIDInvalidEnumValue = 10,
e_FSStringIDUnsupportMethod = 11,
e_FSStringIDUnsupportProperty = 12,
e_FSStringIDInvalidPropertySetOperation = 13,
e_FSStringIDNotDefaultValue = 14,
e_FSStringIDUnableSetLanguage = 15,
e_FSStringIDUnableSetNumPages = 16,
e_FSStringIDUnableSetPlatformValue = 17,
e_FSStringIDUnableSetValidationsEnabledValue = 18,
e_FSStringIDUnableSetValidationsValue = 19,
e_FSStringIDUnableSetVersion = 20,
e_FSStringIDUnableSetReady = 21,
e_FSStringIDNumberOfOccur = 22,
e_FSStringIDUnableSetClassName = 23,
e_FSStringIDUnableSetLengthValue = 24,
e_FSStringIDUnsupportChar = 25,
e_FSStringIDBadSuffix = 26,
e_FSStringIDExpectedIdent = 27,
e_FSStringIDExpectedString = 28,
e_FSStringIDInvalidateChar = 29,
e_FSStringIDRedefinition = 30,
e_FSStringIDInvalidToken = 31,
e_FSStringIDInvalidExpression = 32,
e_FSStringIDUndefineIdentifier = 33,
e_FSStringIDInvalidateLeftValue = 34,
e_FSStringIDCompilerError= 35,
e_FSStringIDCannotModifyValue = 36,
e_FSStringIDParametersError = 37,
e_FSStringIDExpectedEndIf = 38,
e_FSStringIDUnexpectedExpression = 39,
e_FSStringIDConditionIsNull = 40,
e_FSStringIDIllegalBreak = 41,
e_FSStringIDIllegalContinue = 42,
e_FSStringIDExpectedOperator = 43,
e_FSStringIDDivideZero = 44,
e_FSStringIDCannotCovertToObject = 45,
e_FSStringIDNotFoundContainer = 46,
e_FSStringIDNotFoundProperty = 47,
e_FSStringIDNotFoundMethod = 48,
e_FSStringIDNotFoundConst = 49,
e_FSStringIDNotAssignObject= 50,
e_FSStringIDInvalidateInstruction= 51,
e_FSStringIDExpectedNumber = 52,
e_FSStringIDValidateOutOfArray= 53,
e_FSStringIDCannotAssign = 54,
e_FSStringIDNotFoundFunction = 55,
e_FSStringIDIsNotArray = 56,
e_FSStringIDOutOfArrayRange = 57,
e_FSStringIDNotSupportArrayCalculate = 58,
e_FSStringIDArgumentNotArray = 59,
e_FSStringIDArgumentExpectContainer = 60,
e_FSStringIDAccessProertyInNotObject = 61,
e_FSStringIDFunctionBuildIn = 62,
e_FSStringIDErrorMessage = 63,
e_FSStringIDIndexValueOutOfBounds = 64,
e_FSStringIDIncorrectNumberOfMethod = 65,
e_FSStringIDArgumentMismatch  = 66,
e_FSStringIDInvalidEnumerate = 67,
e_FSStringIDInvalidAppend = 68,
e_FSStringIDSOMExpectedList = 69,
e_FSStringIDNotHaveProperty = 70,
e_FSStringIDInvalidNodeType = 71,
e_FSStringIDViolateBoundary = 72,
e_FSStringIDServerDeny = 73,
e_FSStringIDWeekDaySun = 74,
e_FSStringIDWeekDayMon = 75,
e_FSStringIDWeekDayTue = 76,
e_FSStringIDWeekDayWed = 77,
e_FSStringIDWeekDayThu = 78,
e_FSStringIDWeekDayFri = 79,
e_FSStringIDWeekDaySat = 80,
e_FSStringIDMonthJan = 81,
e_FSStringIDMonthFeb = 82,
e_FSStringIDMonthMarch = 83,
e_FSStringIDMonthApril = 84,
e_FSStringIDMonthMay = 85,
e_FSStringIDMonthJune = 86,
e_FSStringIDMonthJuly = 87,
e_FSStringIDMonthAug = 88,
e_FSStringIDMonthSep = 89,
e_FSStringIDMonthOct = 90,
e_FSStringIDMonthNov = 91,
e_FSStringIDMonthDec = 92,
e_FSStringIDToday = 93,
e_FSStringIDValidateLimit = 94,
e_FSStringIDValidateNullWarning = 95,
e_FSStringIDValidateNullError = 96,
e_FSStringIDValidateWarning = 97,
e_FSStringIDValidateError = 98,
e_FSStringIDValidateNumberError = 99,
e_FSStringIDScriptFailedError = 100,
e_FSStringIDScriptInvalidValue = 101,
e_FSStringIDSubmitValidateNullError = 102,
e_FSStringIDInvalidBarcodeValue = 103,
e_FSStringIDScriptArgumentMismatch = 104,
}FSStringID;



typedef enum _FSMsgBoxIconType {
e_FSMsgBoxIconError = 0,
e_FSMsgBoxIconWarning = 1,
e_FSMsgBoxIconQuestion = 2,
e_FSMsgBoxIconStatus = 3,
}FSMsgBoxIconType;



typedef enum _FSMsgBoxButtonType {
e_FSMsgBtnTypeOK = 0,
e_FSMsgBtnTypeOKCancel = 1,
e_FSMsgBtnTypeYesNo = 2,
e_FSMsgBtnTypeYesNoCancel = 3,
}FSMsgBoxButtonType;



typedef enum _FSMsgBoxButtonID {
e_FSMsgBtnIDOK = 1,
e_FSMsgBtnIDCancel = 2,
e_FSMsgBtnIDNo = 3,
e_FSMsgBtnIDYes = 4,
}FSMsgBoxButtonID;



typedef enum _FSInvalidateFlag {
e_FSInvalidateFlagAllPages = 0,
e_FSInvalidateFlagCurrentPage = 1,
}FSInvalidateFlag;



typedef enum _FSPrintOption {
e_FSPrintOptionShowDialog = 0x00000001,
e_FSPrintOptionCanCancel = 0x00000002,
e_FSPrintOptionShrinkPage = 0x00000004,
e_FSPrintOptionAsImage = 0x00000008,
e_FSPrintOptionReverseOrder = 0x00000010,
e_FSPrintOptionPrintAnnot = 0x00000020,
}FSPrintOption;



typedef enum _FSSubmitFormat {
e_FSSubmitInXDP = 0,
e_FSSubmitInPDF = 1,
e_FSSubmitInUrlEncoded = 2,
e_FSSubmitInXFD= 3,
e_FSSubmitInXML = 4,
}FSSubmitFormat;



typedef enum _FSTextEncoding {
e_FSTextEncodingNone = 0,
e_FSTextEncodingBig5 = 1,
e_FSTextEncodingFontSpecific = 2,
e_FSTextEncodingGBK = 3,
e_FSTextEncodingGB18030 = 4,
e_FSTextEncodingGB2312 = 5,
e_FSTextEncodingISO8859NN = 6,
e_FSTextEncodingKSC5601 = 7,
e_FSTextEncodingShiftJIS = 8,
e_FSTextEncodingUCS2 = 9,
e_FSTextEncodingUTF16 = 10,
e_FSTextEncodingUTF8 = 11,
}FSTextEncoding;



typedef enum _FSHitTestArea {
e_FSHitTestAreaHitTestAreaUnknown = 0,
e_FSHitTestAreaClient = 1,
e_FSHitTestAreaTitleBar = 2,
e_FSHitTestAreaHyperLink = 3,
}FSHitTestArea;



typedef enum _FSPresenceProperty {
e_FSPresencePropertyPresenceUnknown = 0,
e_FSPresenceVisible = 1,
e_FSPresenceHidden = 2,
e_FSPresenceInactive = 3,
e_FSPresenceInvisible = 4,
}FSPresenceProperty;



typedef enum _FSEventType {
e_FSEventTypeEventTypeUnknown = 0,
e_FSEventTypePostPrint = 1,
e_FSEventTypePrePrint = 2,
}FSEventType;



typedef enum _FSXFAType {
e_FSDynamic = 0,
e_FSStatic = 1,
e_FSXDP = 2,
}FSXFAType;



typedef enum _FSExportDataType {
e_FSExportDataTypeXML = 0,
e_FSExportDataTypeStaticXDP = 1,
e_FSExportDataTypeXDP = 2,
}FSExportDataType;



typedef enum _FSPageViewEventType {
e_FSPageViewEventTypeAdded = 0,
e_FSPageViewEventTypeRemoved = 1,
e_FSPageViewEventTypeAllRemoved = 2,
}FSPageViewEventType;



typedef enum _FSWidgetEventType {
e_FSWidgetEventTypeAdded = 0,
e_FSWidgetEventTypeBeforeRemoved = 1,
}FSWidgetEventType;



typedef enum _FSWidgetType {
e_FSWidgetTypeBarcode = 0,
e_FSWidgetTypePushButton = 1,
e_FSWidgetTypeCheckButton = 2,
e_FSWidgetTypeArc = 3,
e_FSWidgetTypeDateTimeEdit = 4,
e_FSWidgetTypeNumericEdit = 5,
e_FSWidgetTypeSignature = 6,
e_FSWidgetTypeChoiceList = 7,
e_FSWidgetTypeImageEdit = 8,
e_FSWidgetTypeLine = 9,
e_FSWidgetTypePasswordEdit = 10,
e_FSWidgetTypeRadioButton = 11,
e_FSWidgetTypeRectangle = 12,
e_FSWidgetTypeTextEdit = 13,
e_FSWidgetTypeWidgetTypeUnknown = 14,
e_FSWidgetTypeExclGroup = 15,
e_FSWidgetTypeImage = 16,
}FSWidgetType;



typedef enum _FSWidgetNameType {
e_FSWidgetNameTypeField = 0,
e_FSWidgetNameTypeCaption = 1,
e_FSWidgetNameTypeFullName = 2,
}FSWidgetNameType;



typedef enum _FSWidgetHAlignType {
e_FSWidgethAlignTypeCenter = 128,
e_FSWidgethAlignTypeJustify = 156,
e_FSWidgethAlignTypeJustifyAll = 61,
e_FSWidgethAlignTypeLeft = 252,
e_FSWidgethAlignTypeRadix = 231,
e_FSWidgethAlignTypeRight = 54,
}FSWidgetHAlignType;



typedef enum _FSWidgetVAlignType {
e_FSWidgetvAlignTypeTop = 33,
e_FSWidgetvAlignTypeBottom = 85,
e_FSWidgetvAlignTypeMiddle = 161,
}FSWidgetVAlignType;



typedef enum _FSWidgetEdgePosition {
e_FSWidgetEdgePositionTop = 0,
e_FSWidgetEdgePositionRight = 1,
e_FSWidgetEdgePositionBottom = 2,
e_FSWidgetEdgePositionLeft = 3,
}FSWidgetEdgePosition;


struct FSWidgetChoiceOption {
  FS_WSTR option_label;
  FS_BOOL selected;
};

struct FSAppProviderCallback {
  void* user_data;
  void (*Release)(void* user_data);
  FS_WSTR (*GetAppInfo)(void* user_data, FSAppInfo app_info);
  void (*Beep)(void* user_data, FSBeepType type);
  FSMsgBoxButtonID (*MsgBox)(void* user_data, const wchar_t* message, const wchar_t* title, FSMsgBoxIconType icon_type,
                                FSMsgBoxButtonType button_type);
  FS_WSTR (*FSResponse)(void* user_data, const wchar_t* question, const wchar_t* title, const wchar_t* default_answer,
                           FS_BOOL is_mask);
  FSReaderCallback* (*DownLoadUrl)(void* user_data, const wchar_t* url);
  FS_WSTR (*PostRequestURL)(void* user_data, const wchar_t* url, const wchar_t* data, const wchar_t* content_type,
                                 const wchar_t* encode, const wchar_t* header);
  FS_BOOL (*PutRequestURL)(void* user_data, const wchar_t* url, const wchar_t* data, const wchar_t* encode);
  FS_WSTR (*LoadString)(void* user_data, FSStringID string_id);
  void (*ShowFileDialog)(void* user_data, const wchar_t* string_title, const wchar_t* string_filter,
                                      FS_BOOL is_openfile_dialog, FS_WSTR*& return_stringarray, FS_UINT32& return_stringarray_length);
  
};

struct FSDocProviderCallback {
  void* user_data;
  void (*Release)(void* user_data);
  void (*InvalidateRect)(void* user_data, int page_index, const FSRectF& rect, FSInvalidateFlag flag);
  void (*DisplayCaret)(void* user_data, int page_index, FS_BOOL is_visible, const FSRectF& rect);
  FS_BOOL (*GetPopupPos)(void* user_data, int page_index, float min_popup, float max_popup,
                           const FSRectF& rect_widget, FSRectF& inout_rect_popup);
  FS_BOOL (*PopupMenu)(void* user_data, int page_index, const FSPointF& rect_popup);
  int (*GetCurrentPage)(void* user_data, const FS_XFADOC_HANDLE& doc);
  void (*SetCurrentPage)(void* user_data, const FS_XFADOC_HANDLE& doc, int current_page_index);
  void (*SetChangeMark)(void* user_data, const FS_XFADOC_HANDLE& doc);
  FS_WSTR (*GetTitle)(void* user_data, const FS_XFADOC_HANDLE& doc);
  void (*SetFocus)(void* user_data, FS_XFAWIDGET_HANDLE& xfa_widget);
  void (*ExportData)(void* user_data, const FS_XFADOC_HANDLE& doc, const wchar_t* file_path);
  void (*ImportData)(void* user_data, const FS_XFADOC_HANDLE& doc, const wchar_t* file_path);
  void (*GotoURL)(void* user_data, const FS_XFADOC_HANDLE& doc, const wchar_t*url);
  void (*Print)(void* user_data, const FS_XFADOC_HANDLE& doc, int start_page_index, int end_page_index, FS_UINT32 options);
  FS_ARGB (*GetHighlightColor)(void* user_data, const FS_XFADOC_HANDLE& doc);
  FS_BOOL (*SubmitData)(void* user_data, const FS_XFADOC_HANDLE& doc, const wchar_t*target, FSSubmitFormat format, FSTextEncoding text_encoding,
                          const wchar_t*content);
  void (*PageViewEvent)(void* user_data, int page_index, FSPageViewEventType page_view_event_type);
  void (*WidgetEvent)(void* user_data, const FS_XFAWIDGET_HANDLE& xfa_widget,FSWidgetEventType widget_event_type);
  
};

FSErrorCode FSDK_XFADoc_Create(const FS_PDFDOC_HANDLE& document, FSDocProviderCallback* xfa_doc_provider_handler, FS_XFADOC_HANDLE& xfadoc_return_value);
FSErrorCode FSDK_XFADoc_Create0(const FS_PDFDOC_HANDLE& document, FS_XFADOC_HANDLE& xfadoc_return_value);
FSErrorCode FSDK_XFADoc_IsEmpty(FS_XFADOC_HANDLE& xfadoc_handle, FS_BOOL& return_value);
FSErrorCode FSDK_XFADoc_Release(FS_XFADOC_HANDLE& xfadoc_handle);
FSErrorCode FSDK_XFADoc_StartLoad(FS_XFADOC_HANDLE& xfadoc_handle,  FSPauseCallback* pause, FS_PROGRESSIVE_HANDLE& return_value);
FSErrorCode FSDK_XFADoc_SetDocProviderCallback(FS_XFADOC_HANDLE& xfadoc_handle,  FSDocProviderCallback* doc_provider_callback);
FSErrorCode FSDK_XFADoc_GetType(FS_XFADOC_HANDLE& xfadoc_handle, FSXFAType& return_value);
FSErrorCode FSDK_XFADoc_GetPageCount(FS_XFADOC_HANDLE& xfadoc_handle, int& return_value);
FSErrorCode FSDK_XFADoc_GetPage(FS_XFADOC_HANDLE& xfadoc_handle, int page_index, FS_XFAPAGE_HANDLE& return_value);
FSErrorCode FSDK_XFADoc_ExportData(FS_XFADOC_HANDLE& xfadoc_handle, const wchar_t* output_file_path, FSExportDataType export_type, FS_BOOL& return_value);
FSErrorCode FSDK_XFADoc_SetPDFPath(FS_XFADOC_HANDLE& xfadoc_handle, const wchar_t* pdf_file_path);
FSErrorCode FSDK_XFADoc_ImportData(FS_XFADOC_HANDLE& xfadoc_handle, const wchar_t* file_path, FS_BOOL& return_value);
FSErrorCode FSDK_XFADoc_ResetForm(FS_XFADOC_HANDLE& xfadoc_handle);
FSErrorCode FSDK_XFADoc_FlattenTo(FS_XFADOC_HANDLE& xfadoc_handle, const wchar_t* output_file_path);
FSErrorCode FSDK_XFADoc_FlattenTo0(FS_XFADOC_HANDLE& xfadoc_handle,  FSStreamCallback* stream);
FSErrorCode FSDK_XFADoc_ProcessEvent(FS_XFADOC_HANDLE& xfadoc_handle, FSEventType event_type);
FSErrorCode FSDK_XFADoc_SetFocus(FS_XFADOC_HANDLE& xfadoc_handle, FS_XFAWIDGET_HANDLE xfa_widget);
FSErrorCode FSDK_XFADoc_KillFocus(FS_XFADOC_HANDLE& xfadoc_handle);
FSErrorCode FSDK_XFADoc_GetWidgetByFullName(FS_XFADOC_HANDLE& xfadoc_handle, const wchar_t* full_name, FS_XFAWIDGET_HANDLE& return_value);
FSErrorCode FSDK_XFAPage_Release(FS_XFAPAGE_HANDLE& xfapage_handle);
FSErrorCode FSDK_XFAPage_IsEmpty(FS_XFAPAGE_HANDLE& xfapage_handle, FS_BOOL& return_value);
FSErrorCode FSDK_XFAPage_GetDisplayMatrix(FS_XFAPAGE_HANDLE& xfapage_handle, int left, int top, int width, int height, FSRotation rotate, FSMatrix& return_value);
FSErrorCode FSDK_XFAPage_GetWidth(FS_XFAPAGE_HANDLE& xfapage_handle, float& return_value);
FSErrorCode FSDK_XFAPage_GetHeight(FS_XFAPAGE_HANDLE& xfapage_handle, float& return_value);
FSErrorCode FSDK_XFAPage_GetWidgetAtDevicePoint(FS_XFAPAGE_HANDLE& xfapage_handle, const FSMatrix& matrix, const FSPointF& device_point, float tolerance, FS_XFAWIDGET_HANDLE& return_value);
FSErrorCode FSDK_XFAPage_GetIndex(FS_XFAPAGE_HANDLE& xfapage_handle, int& return_value);
FSErrorCode FSDK_XFAPage_GetWidgetCount(FS_XFAPAGE_HANDLE& xfapage_handle, int& return_value);
FSErrorCode FSDK_XFAPage_GetWidget(FS_XFAPAGE_HANDLE& xfapage_handle, int widget_index, FS_XFAWIDGET_HANDLE& return_value);
FSErrorCode FSDK_XFAPage_GetWidgetByFullName(FS_XFAPAGE_HANDLE& xfapage_handle, const wchar_t* full_name, FS_XFAWIDGET_HANDLE& return_value);
FSErrorCode FSDK_XFAPage_GetFirstWidget(FS_XFAPAGE_HANDLE& xfapage_handle, FS_XFAWIDGET_HANDLE& return_value);
FSErrorCode FSDK_XFAPage_GetLastWidget(FS_XFAPAGE_HANDLE& xfapage_handle, FS_XFAWIDGET_HANDLE& return_value);
FSErrorCode FSDK_XFAPage_GetNextWidget(FS_XFAPAGE_HANDLE& xfapage_handle, const FS_XFAWIDGET_HANDLE& widget, FS_XFAWIDGET_HANDLE& return_value);
FSErrorCode FSDK_XFAPage_GetPrevWidget(FS_XFAPAGE_HANDLE& xfapage_handle, const FS_XFAWIDGET_HANDLE& widget, FS_XFAWIDGET_HANDLE& return_value);
FSErrorCode FSDK_XFAWidget_IsEmpty(FS_XFAWIDGET_HANDLE& xfawidget_handle, FS_BOOL& return_value);
FSErrorCode FSDK_XFAWidget_Release(FS_XFAWIDGET_HANDLE& xfawidget_handle);
FSErrorCode FSDK_XFAWidget_GetXFAPage(FS_XFAWIDGET_HANDLE& xfawidget_handle, FS_XFAPAGE_HANDLE& return_value);
FSErrorCode FSDK_XFAWidget_GetIndex(FS_XFAWIDGET_HANDLE& xfawidget_handle, int& return_value);
FSErrorCode FSDK_XFAWidget_ResetData(FS_XFAWIDGET_HANDLE& xfawidget_handle);
FSErrorCode FSDK_XFAWidget_GetRect(FS_XFAWIDGET_HANDLE& xfawidget_handle, FSRectF& return_value);
FSErrorCode FSDK_XFAWidget_GetValue(FS_XFAWIDGET_HANDLE& xfawidget_handle, FS_WSTR& return_value);
FSErrorCode FSDK_XFAWidget_SetValue(FS_XFAWIDGET_HANDLE& xfawidget_handle, const wchar_t* value);
FSErrorCode FSDK_XFAWidget_GetName(FS_XFAWIDGET_HANDLE& xfawidget_handle, FSWidgetNameType type, FS_WSTR& return_value);
FSErrorCode FSDK_XFAWidget_GetOptions(FS_XFAWIDGET_HANDLE& xfawidget_handle, FSWidgetChoiceOption* return_widget_choice_option_array, FS_UINT32& return_array_length);
FSErrorCode FSDK_XFAWidget_IsChecked(FS_XFAWIDGET_HANDLE& xfawidget_handle, FS_BOOL& return_value);
FSErrorCode FSDK_XFAWidget_GetPresence(FS_XFAWIDGET_HANDLE& xfawidget_handle, FSPresenceProperty& return_value);
FSErrorCode FSDK_XFAWidget_OnMouseEnter(FS_XFAWIDGET_HANDLE& xfawidget_handle, FS_BOOL& return_value);
FSErrorCode FSDK_XFAWidget_OnMouseExit(FS_XFAWIDGET_HANDLE& xfawidget_handle, FS_BOOL& return_value);
FSErrorCode FSDK_XFAWidget_OnLButtonDown(FS_XFAWIDGET_HANDLE& xfawidget_handle, const FSPointF& point, FS_UINT32 flags, FS_BOOL& return_value);
FSErrorCode FSDK_XFAWidget_OnLButtonUp(FS_XFAWIDGET_HANDLE& xfawidget_handle, const FSPointF& point, FS_UINT32 flags, FS_BOOL& return_value);
FSErrorCode FSDK_XFAWidget_OnLButtonDoubleClick(FS_XFAWIDGET_HANDLE& xfawidget_handle, const FSPointF& point, FS_UINT32 flags, FS_BOOL& return_value);
FSErrorCode FSDK_XFAWidget_OnMouseMove(FS_XFAWIDGET_HANDLE& xfawidget_handle, const FSPointF& point, FS_UINT32 flags, FS_BOOL& return_value);
FSErrorCode FSDK_XFAWidget_OnRButtonDown(FS_XFAWIDGET_HANDLE& xfawidget_handle, const FSPointF& point, FS_UINT32 flags, FS_BOOL& return_value);
FSErrorCode FSDK_XFAWidget_OnRButtonUp(FS_XFAWIDGET_HANDLE& xfawidget_handle, const FSPointF& point, FS_UINT32 flags, FS_BOOL& return_value);
FSErrorCode FSDK_XFAWidget_OnKeyDown(FS_XFAWIDGET_HANDLE& xfawidget_handle, FS_UINT32 key_code, FS_UINT32 flags, FS_BOOL& return_value);
FSErrorCode FSDK_XFAWidget_OnKeyUp(FS_XFAWIDGET_HANDLE& xfawidget_handle, FS_UINT32 key_code, FS_UINT32 flags, FS_BOOL& return_value);
FSErrorCode FSDK_XFAWidget_OnChar(FS_XFAWIDGET_HANDLE& xfawidget_handle, int input_char, FS_UINT32 flags, FS_BOOL& return_value);
FSErrorCode FSDK_XFAWidget_OnHitTest(FS_XFAWIDGET_HANDLE& xfawidget_handle, const FSPointF& point, FSHitTestArea& return_value);
FSErrorCode FSDK_XFAWidget_GetType(FS_XFAWIDGET_HANDLE& xfawidget_handle, FSWidgetType& return_value);
FSErrorCode FSDK_XFAWidget_GetHAlign(FS_XFAWIDGET_HANDLE& xfawidget_handle, FSWidgetHAlignType& return_value);
FSErrorCode FSDK_XFAWidget_GetVAlign(FS_XFAWIDGET_HANDLE& xfawidget_handle, FSWidgetVAlignType& return_value);
FSErrorCode FSDK_XFAWidget_HasEdge(FS_XFAWIDGET_HANDLE& xfawidget_handle, FSWidgetEdgePosition edge_pos, FS_BOOL& return_value);
FSErrorCode FSDK_XFAWidget_GetSignature(FS_XFAWIDGET_HANDLE& xfawidget_handle, FS_SIGNATURE_HANDLE& return_value);
FSErrorCode FSDK_XFAWidget_GetToolTip(FS_XFAWIDGET_HANDLE& xfawidget_handle, FS_WSTR& return_value);
FSErrorCode FSDK_XFAWidget_GetBitmap(FS_XFAWIDGET_HANDLE& xfawidget_handle, FS_BITMAP_HANDLE& return_value);
FSErrorCode FSDK_WidgetMenu_Create(const FS_XFAWIDGET_HANDLE& xfa_widget, FS_WIDGETMENU_HANDLE& widgetmenu_return_value);
FSErrorCode FSDK_WidgetMenu_Release(FS_WIDGETMENU_HANDLE& widgetmenu_handle);
FSErrorCode FSDK_WidgetMenu_IsEmpty(FS_WIDGETMENU_HANDLE& widgetmenu_handle, FS_BOOL& return_value);
FSErrorCode FSDK_WidgetMenu_CanCopy(FS_WIDGETMENU_HANDLE& widgetmenu_handle, FS_BOOL& return_value);
FSErrorCode FSDK_WidgetMenu_CanCut(FS_WIDGETMENU_HANDLE& widgetmenu_handle, FS_BOOL& return_value);
FSErrorCode FSDK_WidgetMenu_CanPaste(FS_WIDGETMENU_HANDLE& widgetmenu_handle, FS_BOOL& return_value);
FSErrorCode FSDK_WidgetMenu_CanSelectAll(FS_WIDGETMENU_HANDLE& widgetmenu_handle, FS_BOOL& return_value);
FSErrorCode FSDK_WidgetMenu_CanDelete(FS_WIDGETMENU_HANDLE& widgetmenu_handle, FS_BOOL& return_value);
FSErrorCode FSDK_WidgetMenu_CanDeSelect(FS_WIDGETMENU_HANDLE& widgetmenu_handle, FS_BOOL& return_value);
FSErrorCode FSDK_WidgetMenu_Copy(FS_WIDGETMENU_HANDLE& widgetmenu_handle, FS_WSTR& return_value);
FSErrorCode FSDK_WidgetMenu_Cut(FS_WIDGETMENU_HANDLE& widgetmenu_handle, FS_WSTR& return_value);
FSErrorCode FSDK_WidgetMenu_Paste(FS_WIDGETMENU_HANDLE& widgetmenu_handle, const wchar_t* text, FS_BOOL& return_value);
FSErrorCode FSDK_WidgetMenu_SelectAll(FS_WIDGETMENU_HANDLE& widgetmenu_handle, FS_BOOL& return_value);
FSErrorCode FSDK_WidgetMenu_Delete(FS_WIDGETMENU_HANDLE& widgetmenu_handle, FS_BOOL& return_value);
FSErrorCode FSDK_WidgetMenu_DeSelect(FS_WIDGETMENU_HANDLE& widgetmenu_handle, FS_BOOL& return_value);
FSErrorCode FSDK_WidgetMenu_CanUndo(FS_WIDGETMENU_HANDLE& widgetmenu_handle, FS_BOOL& return_value);
FSErrorCode FSDK_WidgetMenu_CanRedo(FS_WIDGETMENU_HANDLE& widgetmenu_handle, FS_BOOL& return_value);
FSErrorCode FSDK_WidgetMenu_Undo(FS_WIDGETMENU_HANDLE& widgetmenu_handle, FS_BOOL& return_value);
FSErrorCode FSDK_WidgetMenu_Redo(FS_WIDGETMENU_HANDLE& widgetmenu_handle, FS_BOOL& return_value);
FSErrorCode FSDK_WidgetMenu_Bold(FS_WIDGETMENU_HANDLE& widgetmenu_handle, FS_BOOL& return_value);
FSErrorCode FSDK_WidgetMenu_Italic(FS_WIDGETMENU_HANDLE& widgetmenu_handle, FS_BOOL& return_value);
FSErrorCode FSDK_WidgetMenu_Underline(FS_WIDGETMENU_HANDLE& widgetmenu_handle, FS_BOOL& return_value);
FSErrorCode FSDK_WidgetMenu_Superscript(FS_WIDGETMENU_HANDLE& widgetmenu_handle, FS_BOOL& return_value);
FSErrorCode FSDK_WidgetMenu_Subscript(FS_WIDGETMENU_HANDLE& widgetmenu_handle, FS_BOOL& return_value);
FSErrorCode FSDK_WidgetMenu_ClearStyle(FS_WIDGETMENU_HANDLE& widgetmenu_handle, FS_BOOL& return_value);
#ifdef __cplusplus
}
#endif
#endif
